HellishWindow = class( Turbine.UI.Window );
function HellishWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

	self:LoadSettings();

	--Propiedades de Ventana
	self:SetBackColor( Turbine.UI.Color() );
	self:SetSize(500, 460);
	self:SetText("Plugin - Personal Strats");
	self:SetOpacity(1);
	self:SetPosition( windowSettings.positionX, windowSettings.positionY );

-- new awesome Garan code block
	self.DisplayStrat=function(newStratName)
		stratName=newStratName;
		self:SetVisible(false)
		if displayWindow==nil then
			displayWindow=StratDisplayWindow()
		end
		if StratData[stratName]==nil or StratData[stratName].imagePath==nil then
			displayWindow.Background:SetVisible(false);
			displayWindow.CurrentWidth=365;
			displayWindow:SetSize(365, 140);
		else
-- changed to a pcall to avoid failures for missing images 9/16 Garan
			local success,result=pcall(Turbine.UI.Control.SetBackground,displayWindow.Background,StratData[stratName].imagePath);
			displayWindow.Background:SetSize(StratData[stratName].imageWidth,StratData[stratName].imageHeight);
			displayWindow.CurrentWidth=StratData[stratName].imageWidth+10;
			displayWindow:SetSize(StratData[stratName].imageWidth+10,StratData[stratName].imageHeight+80);

-- changed to display based on "success" from pcall 9/16 Garan
			displayWindow.Background:SetVisible(success);
		end


		displayWindow:SetText(stratName);
		displayWindow:ClearDisplay();
		if StratData[stratName]~=nil then
			for k,v in pairs(StratData[stratName]) do
				if type(v)=="table" and v["Button"]~=nil then
               				displayWindow.AddCustomButton(k,v["Button"][1],v["Button"][2],v["Button"][3],v["Display"]);
				end
			end
		end
		displayWindow:SetVisible(true);
	end
-- end new code block

	

                 --Text at top
	self.titleLabel44 = Turbine.UI.Label();
	self.titleLabel44:SetParent( self );
	self.titleLabel44:SetPosition(25, 40);
	self.titleLabel44:SetForeColor( Rojo );
	self.titleLabel44:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.titleLabel44:SetText("Check news of V1.7");	
	self.titleLabel44:SetSize(130, 300);

                -- Boton de Plugin Info
	self.apart2Button = Turbine.UI.Lotro.Button();
	self.apart2Button:SetParent( self );
	self.apart2Button:SetPosition(25, 60);
	self.apart2Button:SetWidth( 135 );
	self.apart2Button:SetText("Plugin Info");
	self.apart2Button.Click = function()
		self.DisplayStrat("Plugin Info");
	end

                 --Texto instances
	self.titleLabel = Turbine.UI.Label();
	self.titleLabel:SetParent( self );
	self.titleLabel:SetPosition(63 , 95);
	self.titleLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.titleLabel:SetText("Instances");	
	self.titleLabel:SetSize(130, 300);

                -- Boton de 3-Mans
	self.apart10Button = Turbine.UI.Lotro.Button();
	self.apart10Button:SetParent( self );
	self.apart10Button:SetPosition(25, 115);
	self.apart10Button:SetWidth( 135 );
	self.apart10Button:SetText("3-Man Instances");
	self.apart10Button.Click = function()
		self.DisplayStrat("3-Man Instances");
	end

                -- Boton de 6-Mans
	self.apart9Button = Turbine.UI.Lotro.Button();
	self.apart9Button:SetParent( self );
	self.apart9Button:SetPosition(25, 140);
	self.apart9Button:SetWidth( 135 );
	self.apart9Button:SetText("6-Man Instances");
	self.apart9Button.Click = function()
		self.DisplayStrat("6-Man Instances");
	end

                 --Texto skirmishes
	self.titleLabel = Turbine.UI.Label();
	self.titleLabel:SetParent( self );
	self.titleLabel:SetPosition(63 , 165);
	self.titleLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.titleLabel:SetText("Skirmishes");	
	self.titleLabel:SetSize(130, 300);

                -- Boton de skirmishes
	self.apart11Button = Turbine.UI.Lotro.Button();
	self.apart11Button:SetParent( self );
	self.apart11Button:SetPosition(25, 185);
	self.apart11Button:SetWidth( 135 );
	self.apart11Button:SetText("Skirmishes");
	self.apart11Button.Click = function()
		self.DisplayStrat("Skirmishes");
	end

	                 --Texto raids
	self.titleLabel = Turbine.UI.Label();
	self.titleLabel:SetParent( self );
	self.titleLabel:SetPosition(310 , 40);
	self.titleLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.titleLabel:SetText("Raids");	
	self.titleLabel:SetSize(80, 20);
	
              -- Boton de Raiding 101
	self.apart2Button = Turbine.UI.Lotro.Button();
	self.apart2Button:SetParent( self );
	self.apart2Button:SetPosition(275, 60);
	self.apart2Button:SetWidth( 105 );
	self.apart2Button:SetText("Raiding 101");
	self.apart2Button.Click = function()
		self.DisplayStrat("Raiding 101");
	end

                -- Boton del Rift
	self.apart5Button = Turbine.UI.Lotro.Button();
	self.apart5Button:SetParent( self );
	self.apart5Button:SetPosition(190, 85);
	self.apart5Button:SetWidth( 135 );
	self.apart5Button:SetText("The Rift");
	self.apart5Button.Click = function()
		self.DisplayStrat("The Rift");
	end

                -- Boton de Helegrod
	self.apart7Button = Turbine.UI.Lotro.Button();
	self.apart7Button:SetParent( self );
	self.apart7Button:SetPosition(335, 85);
	self.apart7Button:SetWidth( 135 );
	self.apart7Button:SetText("Helegrod");
	self.apart7Button.Click = function()
		self.DisplayStrat("Helegrod");
	end

                -- Boton de Filikul
	self.apart8Button = Turbine.UI.Lotro.Button();
	self.apart8Button:SetParent( self );
	self.apart8Button:SetPosition(190, 110);
	self.apart8Button:SetWidth( 135 );
	self.apart8Button:SetText("Filikul");
	self.apart8Button.Click = function()
		self.DisplayStrat("Filikul");
	end

                -- Boton de DN
	self.apart6Button = Turbine.UI.Lotro.Button();
	self.apart6Button:SetParent( self );
	self.apart6Button:SetPosition(335, 110);
	self.apart6Button:SetWidth( 135 );
	self.apart6Button:SetText("Dar Narbugud");
	self.apart6Button.Click = function()
		self.DisplayStrat("Dar Narbugud");
	end

                -- Boton del Watcher
	self.apart3Button = Turbine.UI.Lotro.Button();
	self.apart3Button:SetParent( self );
	self.apart3Button:SetPosition(190, 135);
	self.apart3Button:SetWidth( 135 );
	self.apart3Button:SetText("The Watcher");
	self.apart3Button.Click = function()
		self.DisplayStrat("The Watcher");
	end	

                 -- Boton de BG
	self.apartnotasButton = Turbine.UI.Lotro.Button();
	self.apartnotasButton:SetParent( self );
	self.apartnotasButton:SetPosition(335, 135);
	self.apartnotasButton:SetWidth( 135 );
	self.apartnotasButton:SetText("Barad Guldur");
	self.apartnotasButton.Click = function()
		self.DisplayStrat("Barad Guldur");
	end

                -- Boton de OD tier 2
	self.apart1Button = Turbine.UI.Lotro.Button();
	self.apart1Button:SetParent( self );
	self.apart1Button:SetPosition(190, 160);
	self.apart1Button:SetWidth( 135 );
	self.apart1Button:SetText("Ost Dunhoth");
	self.apart1Button.Click = function()
		self.DisplayStrat("Ost Dunhoth");
	end

                -- Boton de Draigoch
	self.apart4Button = Turbine.UI.Lotro.Button();
	self.apart4Button:SetParent( self );
	self.apart4Button:SetPosition(335, 160);
	self.apart4Button:SetWidth( 135 );
	self.apart4Button:SetText("Draigoch");
	self.apart4Button.Click = function()
		self.DisplayStrat("Draigoch");
	end

                -- Boton de ToO
	self.apart2Button = Turbine.UI.Lotro.Button();
	self.apart2Button:SetParent( self );
	self.apart2Button:SetPosition(190, 185);
	self.apart2Button:SetWidth( 135 );
	self.apart2Button:SetText("Tower of Orthanc");
	self.apart2Button.Click = function()
		self.DisplayStrat("Tower of Orthanc");
	end
	
	                -- Boton de Rohan
	self.rohanraid1 = Turbine.UI.Lotro.Button();
	self.rohanraid1:SetParent( self );
	self.rohanraid1:SetPosition(335, 185);
	self.rohanraid1:SetWidth( 135 );
	self.rohanraid1:SetText("..Rohan Raid..");
	self.rohanraid1.Click = function()
	Turbine.Shell.WriteLine("<rgb=#ff0000>The Rohan raid is not live yet and you just wasted 1 click :D</rgb>\nIf the raid is already live... oops? Check if there is a new version of this plugin.");
	end


-- no more raids past this point

                 --Text that says notes or whatever.
	self.titleLabel = Turbine.UI.Label();
	self.titleLabel:SetParent( self );
	self.titleLabel:SetPosition(15 , 220);
	self.titleLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.titleLabel:SetForeColor( Turbine.UI.Color( 0, 1, 0 ) );
	self.titleLabel:SetText("You can type and save your own notes here.");	
	self.titleLabel:SetSize(400, 20);

                 --Textbox for your own notes
	Settings = { FontSize = "14", WindowOpacity = "0.9" }; 
	self.textInput = Turbine.UI.Lotro.TextBox();
	self.textInput:SetParent( self );
	self.textInput:SetVisible( true );
	self.textInput:SetMouseVisible( true );
	self.textInput:SetPosition(15 , 235);
	self.textInput:SetSize(310, 190);	
	self.textInput:SetText(NotaCargadaVariable);
	

                 -- Boton para guardar las notas
	self.saveButton = Turbine.UI.Lotro.Button();
	self.saveButton:SetParent( self );
	self.saveButton:SetPosition(40, 430);
	self.saveButton:SetWidth( 100 );
	self.saveButton:SetText("Save Notes");
	self.saveButton.Click = function( sender, args )
	self:SaveNota();
	end

                 -- Send to chat button
	self.sendtochatButton = Turbine.UI.Lotro.Button();
	self.sendtochatButton:SetParent( self );
	self.sendtochatButton:SetPosition(150, 430);
	self.sendtochatButton:SetWidth( 150 );
	self.sendtochatButton:SetText("Send notes to Chat");
	self.sendtochatButton.Click = function()
 	self:EnviaralChatNota();
	end
	
-- utilidades
	self.utilidades = Turbine.UI.Label();
	self.utilidades:SetParent( self );
	self.utilidades:SetPosition(365, 240);
	self.utilidades:SetForeColor( Amarillo );
	self.utilidades:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.utilidades:SetText("Useful Tools");	
	self.utilidades:SetSize(130, 20);

	self.ItemsID = Turbine.UI.Lotro.Button();
	self.ItemsID:SetParent( self );
	self.ItemsID:SetPosition(345, 260);
	self.ItemsID:SetWidth( 120 );
	self.ItemsID:SetText("ID Recovery");
	self.ItemsID.Click = function()
		ItemsID:SetVisible( true );
		if Hellish:IsVisible() then
			hellishVisible=true;
			Hellish:SetVisible(false);
		else
			hellishVisible=false;
		end
	end
	
	self.Renameitems = Turbine.UI.Lotro.Button();
	self.Renameitems:SetParent( self );
	self.Renameitems:SetPosition(345, 285);
	self.Renameitems:SetWidth( 120 );
	self.Renameitems:SetText("Items Renamer");
	self.Renameitems.Click = function()
		Rename:SetVisible( true );
		if Hellish:IsVisible() then
			hellishVisible=true;
			Hellish:SetVisible(false);
		else
			hellishVisible=false;
		end
	end
	
	self.Timer = Turbine.UI.Lotro.Button();
	self.Timer:SetParent( self );
	self.Timer:SetPosition(345, 310);
	self.Timer:SetWidth( 120 );
	self.Timer:SetText("Timer");
	self.Timer.Click = function()
		Timercillo:SetVisible( true );
		if Hellish:IsVisible() then
				hellishVisible=true;
				Hellish:SetVisible(false);
			else
				hellishVisible=false;
			end
	end
	
	self.utilidades2 = Turbine.UI.Label();
	self.utilidades2:SetParent( self );
	self.utilidades2:SetPosition(345, 332);
	self.utilidades2:SetForeColor( Verde );
	self.utilidades2:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.utilidades2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.utilidades2:SetText("These tools are in Beta and sometimes they might not work as intended.");	
	self.utilidades2:SetSize(130, 90);

end

                  -- Funcion de guardar notas
function HellishWindow:SaveNota()
	Turbine.Shell.WriteLine("Trying to save Your own notes... - It won't save if u don't see a succesful message -");
	textocopiado = self.textInput:GetText();
	Turbine.PluginData.Save( Turbine.DataScope.Character, "PersonalStratsNotes", textocopiado );
	Turbine.Shell.WriteLine("Succesful save.");
end       


                -- Funciones para cargar posicionamiento de ventanas
function HellishWindow:LoadSettings()
	if type( windowSettings ) ~= "table" then
		windowSettings = { positionX = 100, positionY = 100 };
	else
		if windowSettings.positionX == nil then
			windowSettings.positionX = 100;
		end
		if windowSettings.positionY == nil then
			windowSettings.positionY = 100;
		end
	end
end

                  -- Funcion de enviar nota al chat
function HellishWindow:EnviaralChatNota()
	textocopiado = self.textInput:GetText();
	Turbine.Shell.WriteLine("Note: " .. textocopiado);
end                                               


-- the generic AddCallback and RemoveCallback functions that allow supporting multiple handlers for each event.
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            local i;
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end